package person;

import java.util.Objects;

public class Person {

    private final String firstName;
    private final String lastName;
    private final String job;
    private final int gender;
    private final int yearOfBirth;

    private Person (String firstName, String lastName, String job, int gender, int yearOfBirth) {
        // az ellenorzesek kiemelhetok egy vagy tobb privat static segedmetodusba
        if (firstName == null) {
            throw new IllegalArgumentException("first name cannot be null");
        }
        if (lastName == null) {
            throw new IllegalArgumentException("last name cannot be null");
        }
        int currentYear = 2017; // nyilvan ezt ki kellene szamolni
        if (yearOfBirth < 1900 || yearOfBirth > currentYear + 1) {
            throw new IllegalArgumentException("invalid year of birth: " + yearOfBirth);
        }
        this.firstName = firstName;
        this.lastName = lastName;
        this.job = job;
        this.gender = gender;
        this.yearOfBirth = yearOfBirth;
    }

    public static Person makePerson(String firstName, String lastName, String job, int gender, int yearOfBirth) {
        return new Person(firstName, lastName, job, gender, yearOfBirth);
    }

}